/* 
 *
 *   Kodak ESP Cxxx (OPL?) Control Language filters for the  Common UNIX
 *   Printing System (CUPS).
 *  common functions for c2esp, c2espC filters header file
 *
 *  copyright Paul Newall May 2010 - Oct 2011. VERSION 1 (first used in c2esp21~rc3) 
 *
 */


//#include <cups/raster.h>
#include <cups/sidechannel.h> //FlushBackChannel, and the side channel functions and constants
#include <fcntl.h> //files
//#include <sys/stat.h>
//#include <signal.h>
//#include <errno.h>
//#include <cups/driver.h> //has the dither functions probably not needed for Cxxx
#include <time.h> //time functions used for debugging


/*
 * Constants...

char	*Version = "c2espcommon01";
unsigned char ESC = 255;
unsigned char NL = 10;
 */

/*
 * Globals...
 
char		CallerName[50];  	// String that identifies the calling program 
int		DoBack;			// Enables the back channel comms 
char 		BackBuf[32000]; //for the back channel replies from the printer
int 		BackBufLen=sizeof(BackBuf)-1;
FILE 		*LogFile = NULL; //file descriptor for log file
*/
char 		BackBuf[32000]; //for the back channel replies from the printer
int		ColourPercent, BlackPercent; //to store the detected marker levels

void SetupLogging(char *ExtCallerName, int ExtDoBack, char *ExtLogFileName);

void CloseLogging();

void DoLog(char *PrintFormat, int I1, int I2);
	//prints a line with 2 integers to the log file and the cups error log

void DoLogString(char *PrintFormat, char *String);
	//prints a line with a string to the log file and the cups error log

/* DoOutJob used to enable one call to send to the specified job file and to stdout (if not testing)
And log the result */
void DoOutJob(FILE *OutFile, char *PrintFormat, int I1, int I2);


/* FlushBackChannel gets rid of any previous reply that could cause confusion */
int FlushBackChannel(char *IdString, float DrainTime);
//returns 1 if sucessful

/* GoodExchange sends a command gets reply from the printer on the back channel and compares it with the expected reply
	It returns the number of bytes read if the reply was the one expected, 
	otherwise -(the number of bytes read) if the reply did not match Expect, or 0 if there was no reply */
int GoodExchange(FILE *PrintFile, char *Command, char *Expect, int DoBack,  unsigned int SleepTime, float ReplyTime);

int MarkerPercent(char *Buf, int GetColour); /* GetColour = 1 for "Color" or 0 for "Black" */

void MarkerSetup();

void SetPaperSize(char Size[], int PaperPoints);
    //converts length of page in cups header (in points) into a string that the printer recognises

void DisplayHeader(cups_page_header2_t *header);
 /*
  * Show page device dictionary in stderr and LogFile
  */

